package net.sf.jolene.dom;

/**
 * A checkbox in a html document.
 *
 * @author Dan Howard
 * @since Oct 14, 2005 6:18:36 AM
 */
public final class CheckBox extends HTMLElement {
    /**
     * Default constructor.
     */
    public CheckBox() {
        setAttribute("type", "checkbox");
    }

    /**
     * Construct a checkbox with the specified name.
     *
     * @param name name of the checkbox.
     */
    public CheckBox(String name) {
        setName(name);
        setAttribute("type", "checkbox");
    }

    /**
     * Returns a clone of the checkbox object.
     *
     * @return CheckBox object.
     */
    @Override
    public CheckBox clone() {
        return (CheckBox) super.clone();
    }

    /**
     * Sets the name of the checkbox.
     *
     * @param name name of the checkbox.
     */
    @Override
    public void setName(String name) {
        super.setName(name);
        setAttribute("name", name);
    }

    /**
     * Sets the value of the checbox. See setChecked to indicate it has been checked.
     *
     * @param value value of the checkbox.
     * @see net.sf.jolene.dom.HTMLElement#setChecked(boolean)
     */
    @Override
    public void setValue(String value) {
        super.setValue(value);
        setAttribute("value", value);
    }
}
