package net.sf.jolene.dom;

/**
 * Exception thrown by the grid's bind method. It's a wrapper around exceptions thrown by BeanUtils.
 * Specifically:
 * IllegalAccessException
 * InvocationTargetException
 * NoSuchMethodException
 *
 * @author Dan Howard
 * @since Sep 1, 2008 7:33:41 AM
 */
public final class GridBindException extends RuntimeException {

    /**
     *
     */
    public GridBindException() {
    }

    /**
     * Constructs the exception with the specified message string.
     *
     * @param message - message string
     */
    public GridBindException(String message) {
        super(message);
    }

    /**
     * Constructs the exception with the specified cause.
     *
     * @param cause - cause of the exception
     */
    public GridBindException(Throwable cause) {
        super(cause);
    }

    /**
     * Constructs the exception with the specified message string and cause.
     *
     * @param message - message string
     * @param cause   - cause of the exception
     */
    public GridBindException(String message, Throwable cause) {
        super(message, cause);
    }

}
