/*
 * Created on Feb 8, 2004
*/
package net.sf.jolene.dom;


/**
 * An input field in a html document. Usually used for entry fields, hidden fields or buttons.
 * Use CheckBox and Radio for checkboxes and radio buttons.
 *
 * @author Dan Howard
 */
public final class Input extends HTMLElement {

    /**
     * Default constructor.
     */
    public Input() {
    }

    /**
     * Construct an input object with the specified name.
     *
     * @param name name of the input.
     */
    public Input(String name) {
        setName(name);
    }

    /**
     * Returns a clone of the input object.
     *
     * @return Input object.
     */
    @Override
    public Input clone() {
        return (Input) super.clone();
    }

    /**
     * Sets the name of the input object.
     *
     * @param name name of the input.
     */
    @Override
    public void setName(String name) {
        super.setName(name);
        setAttribute("name", name);
    }


    /**
     * Sets the value of the input object.
     *
     * @param value value of the input.
     */
    @Override
    public void setValue(String value) {
        super.setValue(value);
        setAttribute("value", value);
    }
}
