package net.sf.jolene.dom;

import net.sf.jolene.constants.Tags;

/**
 * A lable in an html document.
 *
 * @author Dan Howard
 * @since Oct 19, 2003
 */
public final class Label extends HTMLElement {

    /**
     * Default constructor.
     */
    public Label() {
        tag = Tags.label;
    }


    /**
     * Returns a clone of the label object.
     *
     * @return Label object.
     */
    @Override
    public Label clone() {
        return (Label) super.clone();
    }

    /**
     * Sets the value of the label. Same as setText.
     * @param value text value of the label.
     */
    @Override
    public void setValue(String value) {
        super.setValue(value);
        setContent(value);
    }


    /**
     * Renders the label.
     *
     * @return The label as a html string.
     */
    @Override
    public String toString() {

        if (swapWith != null) {
            return swapWith.toString();
        }

        if (!isRenderable() && !log.isDebugEnabled()) {
            return "";
        }

        return super.toString() + getContent() + "</" + tag + '>';
    }
}
