package net.sf.jolene.dom;

/**
 * This represents arbitrary text to be rendered in an html document.
 * These objects are created when the Parser detects a LABEL tag containing other HTML elements.
 *
 * @author Dan Howard
 * @since Feb 11, 2006 8:21:44 AM
 */
public final class Text extends HTMLElement {
    /**
     * Returns a clone of the text object.
     *
     * @return Text object.
     */
    @Override
    public Text clone() {
        return (Text) super.clone();
    }

    /**
     * Sets the text on the text object. Same as setText.
     * @param value text to set.
     */
    @Override
    public void setValue(String value) {
        super.setValue(value);
        setContent(value);
    }

    /**
     * Renders the text.
     *
     * @return The text as a html string.
     */
    @Override
    public String toString() {
        return getContent();
    }
}
