/*
 * Created on Jan 1, 2004
*/
package net.sf.jolene.html;

import net.sf.jolene.constants.Prefs;

/**
 * Some html utilites.
 *
 * @author Dan Howard
 */
public class HTMLString {

    private HTMLString() {
    }

    public static String head(int n, String s) {
        return "<h" + n + '>' + s + "</h" + n + '>';
    }

    public static String linebreak() {
        if (Boolean.parseBoolean(Prefs.XHTMLStrict.getValue())) {
            return "<br />";
        } else {
            return "<br>";
        }
    }

    public static String paragraph(String s) {
        return "<p>" + s + "</p>";
    }

    public static String preformat(String s) {
        return "<pre>" + s + "</pre>";
    }

    public static String hr() {
        if (Boolean.parseBoolean(Prefs.XHTMLStrict.getValue())) {
            return "<hr />";
        } else {
            return "<hr>";
        }
    }

    public static String image(String image, String alt, String align) {
        String end;
        if (Boolean.parseBoolean(Prefs.XHTMLStrict.getValue())) {
            end = "' />";
        } else {
            end = "'>";
        }
        return "<img align='" + align + "' src='" + image + "' alt='" + alt + end;
    }

    public static String image(String image, String alt) {
        String end;
        if (Boolean.parseBoolean(Prefs.XHTMLStrict.getValue())) {
            end = "' />";
        } else {
            end = "'>";
        }
        return "<img src='" + image + "' alt='" + alt + end;
    }

    public static String image(String image) {
        String end;
        if (Boolean.parseBoolean(Prefs.XHTMLStrict.getValue())) {
            end = "' />";
        } else {
            end = "'>";
        }
        return "<img src='" + image + end;
    }


    public static String link(String url, String text) {
        return "<a href='" + url + "'>" + text + "</a>";
    }

    public static String link(String url, String text, String image) {
        return "<a href='" + url + "'>" + text + "<img src='" + image + "'></a>";
    }

// TODO the List method should use recursion....
//	public String List(String[] aList, boolean ordered) {
//		String s = "";
//		String ls = System.getProperty("line.separator");
//		
//		if (ordered) {
//			s = "<OL>" + ls;
//		}
//		else {
//			s = "<UL>" + ls;
//		}
//		
//		for (int j=0; j < aList.length; j++) {
//			
//		}
//		return s;
//	}

    public static String bold(String s) {
        return "<b>" + s + "</b>";
    }

    public static String italics(String s) {
        return "<i>" + s + "</i>";
    }

}
