package domlet.kbsample.web.actions;

import domlet.kbsample.managers.ContextInfo;
import domlet.kbsample.managers.constants.UserTypes;
import net.sf.jolene.dom.Document;
import net.sf.jolene.struts.DomletAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created by IntelliJ IDEA.
 * User: Dan Howard
 * Date: Sep 9, 2006
 * Time: 1:17:38 PM
 */
public class MenuAction extends DomletAction {

    public ActionForward menu(ActionMapping mapping,
                              ActionForm aform,
                              HttpServletRequest request,
                              HttpServletResponse response) throws Exception {

        ContextInfo contextInfo = ContextInfo.getInstance(request);
        try {
            Document document = getDocument(mapping, request);
            if (contextInfo.getUser() != null) {
                document.forms(0).elements("LoginOrOut").setValue("Log out");
                document.forms(0).elements("LoginOrOut").setAttribute("onclick", "doLogout()");
                document.forms(0).elements("welcome").setValue("Welcome, " + contextInfo.getUser().getName() + ".");

                if (!UserTypes.Admin.toString().equalsIgnoreCase(contextInfo.getUser().getTypeOfUser())) {
                    document.forms(0).elements("Users").setRenderable(false);
                }
            } else {
                document.forms(0).elements("LoginOrOut").setValue("Log in");
                document.forms(0).elements("LoginOrOut").setAttribute("onclick", "doLogin()");
                document.forms(0).elements("Users").setRenderable(false);
            }
        } finally {
            contextInfo.cleanUp();
        }
        return mapping.findForward("success");
    }
}    