package domlet.kbsample.web.forms;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: DanH
 * Date: Oct 22, 2005
 * Time: 6:15:08 PM
 */
public class ArticleSearchForm extends ActionForm {

    private static final Logger log = LogManager.getLogger(ArticleSearchForm.class);

    private String subject;
    private int category;
    private String creator;
    private String modifier;
    private List gridData;

    private String dateField1;
    private String dateField2;
    private Date modifiedStart;
    private Date modifiedEnd;

    private int[] selectedItems = {};

    public Date getModifiedStart() {
        return modifiedStart;
    }

    public Date getModifiedEnd() {
        return modifiedEnd;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public int getCategory() {
        return category;
    }

    public void setCategory(int category) {
        this.category = category;
    }

    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getModifier() {
        return modifier;
    }

    public void setModifier(String modifier) {
        this.modifier = modifier;
    }


    public List getGridData() {
        return gridData;
    }

    public void setGridData(List gridData) {
        this.gridData = gridData;
    }

    public String getDateField1() {
        return dateField1;
    }

    public void setDateField1(String dateField1) {
        // "Sat Aug 20 2005"
        this.dateField1 = dateField1;

        modifiedStart = null;
        if (dateField1 != null && dateField1.length() > 0) {
            try {
                modifiedStart = new SimpleDateFormat("MMM d yyyy").parse(dateField1);
            } catch (ParseException e) {
                log.warn(e.getMessage() + " setDateField1 datefield: " + dateField1);
            }
        }

    }

    public String getDateField2() {
        return dateField2;
    }

    public void setDateField2(String dateField2) {
        this.dateField2 = dateField2;
        modifiedEnd = null;
        if (dateField2 != null && dateField2.length() > 0) {
            try {
                modifiedEnd = new SimpleDateFormat("MMM d yyyy").parse(dateField2);
            } catch (ParseException e) {
                log.warn(e.getMessage() + " setDateField2 datefield: " + dateField2);
            }
        }
    }


    public int[] getSelectedItems() {
        return selectedItems;
    }

    public void setSelectedItems(int[] selectedItems) {
        this.selectedItems = selectedItems;
    }

    public void reset(ActionMapping mapping, HttpServletRequest request) {
        super.reset(mapping, request);

        subject = "";
        category = 0;
        creator = "";
        modifier = "";
        gridData = null;

        dateField1 = "";
        dateField2 = "";
        modifiedStart = null;
        modifiedEnd = null;
    }
}
