package domlet.kbsample.web.viewValues;

import domlet.kbsample.data.Article;
import net.sf.jolene.dom.Button;
import net.sf.jolene.dom.HTMLElement;
import net.sf.persist.annotations.NoColumn;
import net.sf.persist.annotations.Table;
import net.sf.persist.annotations.NoTable;
import net.sf.persist.annotations.Column;

import java.text.SimpleDateFormat;

/**
 * Created by IntelliJ IDEA.
 * User: DanH
 * Date: Dec 29, 2005
 * Time: 7:27:10 AM
 */
@NoTable
public class ArticleView extends Article {

    private HTMLElement button;
    private SimpleDateFormat dateFormat;

    private String creatorName;
    private String modifierName;

    public ArticleView() {
        //super();
        button = new Button();
        button.setAttribute("type", "button");
        button.setAttribute("class", "buttons");
        dateFormat = new SimpleDateFormat("MMM d yyyy HH:mm");
    }


    /**
     * TODO report to persist Overridden to hide @Column(autoGenerated = true) annotation 
     * @return id
     */
    @Override
    public int getId() {
        return super.getId();
    }

    @NoColumn
    public String getEdit() {
        button.setAttribute("onclick", "editArticle(" + getId() + ')');
        button.setContent("Edit");
        return button.toString();
    }

    @NoColumn
    public String getDelete() {
        button.setAttribute("onclick", "deleteArticle(" + getId() + ')');
        button.setContent("Delete");
        return button.toString();
    }

    @NoColumn
    public String getView() {
        button.setAttribute("onclick", "viewArticle(" + getId() + ')');
        button.setContent("View");
        return button.toString();
    }

    @NoColumn
    public String getCreatedString() {
        if (getCreated() != null) {
            return dateFormat.format(getCreated());
        }
        return "";
    }

    @NoColumn
    public String getModifiedString() {
        if (getModified() != null) {
            return dateFormat.format(getModified());
        }
        return "";
    }


    public String getCreatorName() {
        return creatorName;
    }

    public void setCreatorName(String creatorName) {
        this.creatorName = creatorName;
    }

    public String getModifierName() {
        return modifierName;
    }

    public void setModifierName(String modifierName) {
        this.modifierName = modifierName;
    }
}
