package net.sf.jolene.dom;

/**
 * Exception thrown by the form's popluate method. It's a wrapper around exceptions thrown by BeanUtils.
 * Specifically:
 * IllegalAccessException
 * InvocationTargetException
 * NoSuchMethodException
 *
 * @author Dan Howard
 * @since Sep 1, 2008 7:21:42 AM
 */
public final class FormPolulateException extends RuntimeException {

    /**
     *
     */
    public FormPolulateException() {
    }

    /**
     * Constructs the exception with the specified message string.
     *
     * @param message - message string
     */
    public FormPolulateException(String message) {
        super(message);
    }

    /**
     * Constructs the exception with the specified cause.
     *
     * @param cause - cause of the exception
     */
    public FormPolulateException(Throwable cause) {
        super(cause);
    }

    /**
     * Constructs the exception with the specified message string and cause.
     *
     * @param message - message string
     * @param cause   - cause of the exception
     */
    public FormPolulateException(String message, Throwable cause) {
        super(message, cause);
    }

}
