package net.sf.jolene.dom;

import net.sf.jolene.constants.Tags;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author Dan Howard
 * @since Aug 1, 2005 5:55:08 PM
 */
final class GridRow extends HTMLElement {

    List<GridCell> cells;
    boolean header = false;

    GridRow() {
        tag = Tags.tr;
        cells = new ArrayList<GridCell>(0);
    }

    GridCell cells(int cell) {
        return cells.get(cell);
    }

    @Override
    public String toString() {

        StringBuilder sb = new StringBuilder(super.toString());
        String lf = System.getProperty("line.separator");

        Iterator<GridCell> it;
        it = cells.iterator();

        sb.append(lf);
        while (it.hasNext()) {
            GridCell cell = it.next();
            cell.setHeader(header);
            sb.append('\t').append(cell).append(lf);
        }
        sb.append("</").append(tag).append('>').append(lf);
        return sb.toString();
    }

    public boolean isHeader() {
        return header;
    }

    public void setHeader(boolean header) {
        this.header = header;
    }


    @Override
    public final GridRow clone() {
        return (GridRow) super.clone();
    }
}
