package net.sf.jolene.dom;

/**
 * A radio button in an html document.
 *
 * @author Dan Howard
 * @since Oct 13, 2005 8:25:11 PM
 */
public final class Radio extends HTMLElement {

    /**
     * Default constructor.
     */
    public Radio() {
        setAttribute("type", "radio");
    }


    /**
     * Construct a radio button with the specified name.
     *
     * @param name name of the radio button.
     */
    public Radio(String name) {
        this();
        setName(name);
    }

    /**
     * Returns a clone of the radio button object.
     *
     * @return Radio object.
     */
    @Override
    public Radio clone() {
        return (Radio) super.clone();
    }

    /**
     * Set the name of the radio button.
     *
     * @param name name of the radio button.
     */
    @Override
    public void setName(String name) {
        super.setName(name);
        setAttribute("name", name);
    }


    /**
     * Set the value of the radio button.
     *
     * @param value name of the radio button.
     */
    @Override
    public void setValue(String value) {
        super.setValue(value);
        setAttribute("value", value);
    }
}