package net.sf.jolene;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import junit.framework.TestCase;

import java.util.StringTokenizer;

/**
 * @todo finish TokenizerTest and put it in suite (move tests to ParserTest)
 * Created by IntelliJ IDEA.
 * User: DanH
 * Date: Aug 1, 2005
 * Time: 7:17:44 PM
 */
public class TokenizerTest extends TestCase {

    private static final Logger log = LogManager.getLogger(TokenizerTest.class);

    protected void setUp() throws Exception {
        super.setUp();
    }

    public void testTokenizer() {

        String s1 = "1234/";

        if (s1.charAt(s1.length() - 1) == '/') {
            s1 = s1.substring(0, s1.length() - 1);
        }

        log.debug(s1);

        String s = "src=\"http://www.jetbrains.net/idea/download/../../img/logo_bw.gif\" width=\"124\" height=\"44\" alt=\"JetBrains logo\"/";

        StringTokenizer st = new StringTokenizer(s);
        int tokenCount = st.countTokens();
        int currentToken = 0;
        log.debug("tokens: " + tokenCount);

        while (st.hasMoreTokens()) {
            String c = st.nextToken();

            String key, value;
            int n = c.indexOf("=");
            if (n > -1) {
                key = c.substring(0, n);
                value = c.substring(n + 1);
                while ((value.startsWith("\"") && !value.endsWith("\""))
                        || (value.startsWith("'") && !value.endsWith("'"))) {

                    c = st.nextToken();
                    currentToken++;

                    value += " " + c;

                    if (currentToken > tokenCount) {
                        // This would indicate a malformed html string. example:
                        // Left quoted but no right quote.
                        break;
                    }
                }


            } else {
                key = c;
                value = "true";
            }


            log.debug(c);
            log.debug("key :" + key + " value: " + value);
        }
    }

    public void testTranslatePaths() {
        String src = ".\\..\\js\\test.js";
        src = src.replace('\\', '/');
        log.info(src);
        StringTokenizer st = new StringTokenizer(src,"/");
        while (st.hasMoreElements()) {
            log.info(st.nextElement());
        }
        fail("moo");
    }

    protected void tearDown() throws Exception {
        super.tearDown();
    }
}
