/**
 * Created by IntelliJ IDEA.
 * User: DanH
 * Date: Dec 7, 2005
 * Time: 9:58:42 PM
 */
package net.sf.jolene.dom;

import junit.framework.TestCase;
import net.sf.jolene.factories.DocumentFactory;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import java.io.StringWriter;
import java.io.IOException;
import java.net.URL;

public class DocumentCloningTest extends TestCase {

    private static final Logger log = LogManager.getLogger(DocumentCloningTest.class);

    protected void setUp() throws Exception {
        super.setUp();
    }

    protected void tearDown() throws Exception {
        super.tearDown();
    }


    public void testCloneAgainstOriginal() {
        Document doc;
        Document doc1;

        URL url = getClass().getResource("/resources/CloneTest.html");


        try {
            doc = new Document(url.getFile());
            doc1 = DocumentFactory.getInstance().getDocument(url.getFile());

            StringWriter sw = new StringWriter();
            doc.streamResults(sw);
            assertEquals("content s/b", "form : 0 <form action=\"\" enctype=\"multipart/form-data\" method=\"post\" name=\"form1\">\n" +
                    "element : 0\n" +
                    "<input name=\"textfield\" type=\"text\" value=\"a\">\n" +
                    "element : 1\n" +
                    "<textarea name=\"textarea\">b</textarea>\n" +
                    "element : 2\n" +
                    "<input name=\"Submit\" type=\"submit\" value=\"COW\">\n" +
                    "element : 3\n" +
                    "<input name=\"checkbox\" type=\"checkbox\" value=\"checkbox\">\n" +
                    "element : 4\n" +
                    "<input name=\"radiobutton\" type=\"radio\" value=\"radiobutton\">\n" +
                    "element : 5\n" +
                    "<select name=\"select\">\n" +
                    "<option value=\"A\">A</option>\n" +
                    "<option value=\"B\">B</option>\n" +
                    "<option value=\"C\">C</option>\n" +
                    "</select>\n" +
                    "\n" +
                    "element : 6\n" +
                    "<input name=\"file\" type=\"file\">\n" +
                    "element : 7\n" +
                    "<input border=\"1\" height=\"212\" name=\"imageField\" src=\"Sample.jpg\" type=\"image\" width=\"283\">\n" +
                    "element : 8\n" +
                    "<input name=\"hiddenField\" type=\"hidden\" value=\"hidden\">\n" +
                    "element : 9\n" +
                    "<label id=\"hello\">hello</label>\n" +
                    "element : 10\n" +
                    "<table border=\"1\" class=\"Grid\" id=\"grid1\" width=\"100%\">\n" +
                    "<tr>\n" +
                    "\t<td scope=\"col\">a</td>\n" +
                    "\t<td scope=\"col\">b</td>\n" +
                    "\t<td scope=\"col\">c</td>\n" +
                    "</tr>\n" +
                    "\n" +
                    "<tr>\n" +
                    "\t<td>1</td>\n" +
                    "\t<td>2</td>\n" +
                    "\t<td>3</td>\n" +
                    "</tr>\n" +
                    "\n" +
                    "</table>\n" +
                    "\n" +
                    "element : 11\n" +
                    "<img id=\"img1\" src=\"Sample.jpg\">\n", sw.toString().replace("\r",""));


            sw = new StringWriter();
            doc1.streamResults(sw);
            assertEquals("content s/b", "form : 0 <form action=\"\" enctype=\"multipart/form-data\" method=\"post\" name=\"form1\">\n" +
                    "element : 0\n" +
                    "<input name=\"textfield\" type=\"text\" value=\"a\">\n" +
                    "element : 1\n" +
                    "<textarea name=\"textarea\">b</textarea>\n" +
                    "element : 2\n" +
                    "<input name=\"Submit\" type=\"submit\" value=\"COW\">\n" +
                    "element : 3\n" +
                    "<input name=\"checkbox\" type=\"checkbox\" value=\"checkbox\">\n" +
                    "element : 4\n" +
                    "<input name=\"radiobutton\" type=\"radio\" value=\"radiobutton\">\n" +
                    "element : 5\n" +
                    "<select name=\"select\">\n" +
                    "<option value=\"A\">A</option>\n" +
                    "<option value=\"B\">B</option>\n" +
                    "<option value=\"C\">C</option>\n" +
                    "</select>\n" +
                    "\n" +
                    "element : 6\n" +
                    "<input name=\"file\" type=\"file\">\n" +
                    "element : 7\n" +
                    "<input border=\"1\" height=\"212\" name=\"imageField\" src=\"Sample.jpg\" type=\"image\" width=\"283\">\n" +
                    "element : 8\n" +
                    "<input name=\"hiddenField\" type=\"hidden\" value=\"hidden\">\n" +
                    "element : 9\n" +
                    "<label id=\"hello\">hello</label>\n" +
                    "element : 10\n" +
                    "<table border=\"1\" class=\"Grid\" id=\"grid1\" width=\"100%\">\n" +
                    "<tr>\n" +
                    "\t<td scope=\"col\">a</td>\n" +
                    "\t<td scope=\"col\">b</td>\n" +
                    "\t<td scope=\"col\">c</td>\n" +
                    "</tr>\n" +
                    "\n" +
                    "<tr>\n" +
                    "\t<td>1</td>\n" +
                    "\t<td>2</td>\n" +
                    "\t<td>3</td>\n" +
                    "</tr>\n" +
                    "\n" +
                    "</table>\n" +
                    "\n" +
                    "element : 11\n" +
                    "<img id=\"img1\" src=\"Sample.jpg\">\n", sw.toString().replace("\r",""));

            // Check for sameness
            Form form;
            for (int i = 0; i < doc.forms.size(); i++) {
                form = doc.forms(i);
                for (int j = 0; j < form.elements.size(); j++) {
                    log.info("Object #" + j);
                    log.info("Original: " + form.elements(j));
                    log.info("Clone   : " + doc1.forms(i).elements(j));
                    log.info("SAME? " + form.elements(j).toString().equals(doc1.forms(i).elements(j).toString()));
                    assertEquals("Object " + j + " s/b the same: - ", form.elements(j).toString(), doc1.forms(i).elements(j).toString());
                }
            }

            // check for no cross linking.
            for (int i = 0; i < doc.forms.size(); i++) {
                form = doc.forms(i);
                for (int j = 0; j < form.elements.size(); j++) {
                    form.elements(j).setValue("!!!!TESTING!!!!!");
                    log.info("s/n/b same: " + form.elements(j) + " AND " + doc1.forms(i).elements(j));
                    assertNotSame("Object " + j + " s/n/b the same: - ", form.elements(j).toString(), doc1.forms(i).elements(j).toString());

                }
            }

            for (int i = 0; i < doc.head.size(); i++) {
                doc.head.get(i).setValue("!!!!!TESTING!!!!!");
                log.info("s/n/b same: " + doc.head.get(i) + " AND " + doc1.head.get(i));
                assertNotSame("Object " + i + " s/n/b the same: - ", doc.head.get(i).toString(), doc1.head.get(i).toString());
            }

            // test swapWith
            Button button1 = new Button("test");
            button1.setContent("Button text");
            log.info(button1);
            button1.swapWith("COW");
            Button button2 = button1.clone();
            assertEquals("button1 and button2 s/b same", button1.toString(), button2.toString());

        } catch (IOException e) {
            log.error(e.getMessage(), e);
            fail(e.getMessage());
        }

    }

    public void testModifyOneWithoutTheOther() {
        //@todo Create tests to modify 2 document clones and make sure that there is no object pointer issues
    }
}
