package net.sf.jolene.html;

import junit.framework.TestCase;
import org.apache.log4j.Logger;
import org.apache.log4j.LogManager;

/**
 * Created by IntelliJ IDEA.
 * User: DanH
 * Date: Oct 14, 2005
 * Time: 6:28:45 AM
 */
public class HTMLStringTest extends TestCase {

    private final static Logger log = LogManager.getLogger(HTMLStringTest.class);

    public void testHead() {

        String s;
        s = HTMLString.head(1,"hello");
        log.info(s);
        assertEquals("testHead", s, "<h1>hello</h1>");

    }

    public void testLineBreak() {
        String s;
        s = HTMLString.linebreak();
        log.info(s);
        assertEquals("testLineBreak", s, "<br>");


    }

    public void testParagraph() {
        String s;
        s = HTMLString.paragraph("hello");
        log.info(s);
        assertEquals("testParagraph", s, "<p>hello</p>");
    }

    public void testPreFormat() {
        String s;
        s = HTMLString.preformat("hello");
        log.info(s);
        assertEquals("testPreFormat", s,"<pre>hello</pre>");
    }

    public void testHR() {
        String s;
        s = HTMLString.hr();
        log.info(s);
        assertEquals("testHR", s, "<hr>");

    }

    /*
     * Test for String Image(String, String, String)
     */
    public void testImageStringStringString() {
        String s;
        s = HTMLString.image("/images/cow.gif", "cow", "right");
        log.info(s);
        assertEquals("testImageStringStringString", s, "<img align='right' src='/images/cow.gif' alt='cow'>");
    }

    /*
     * Test for String Image(String, String)
     */
    public void testImageStringString() {
        String s;
        s = HTMLString.image("/images/cow.gif", "cow");
        log.info(s);
        assertEquals("testImageStringString", s, "<img src='/images/cow.gif' alt='cow'>");
    }

    /*
     * Test for String Image(String)
     */
    public void testImageString() {
        String s;
        s = HTMLString.image("/images/cow.gif");
        log.info(s);
        assertEquals("testImageString", s, "<img src='/images/cow.gif'>");
    }

    /*
     * Test for String Link(String, String)
     */
    public void testLinkStringString() {

        String s;
        s = HTMLString.link("/images/cow.gif","click for cow!");
        log.info(s);
        assertEquals("testLinkStringString", s, "<a href='/images/cow.gif'>click for cow!</a>");

    }

    /*
     * Test for String Link(String, String, String)
     */
    public void testLinkStringStringString() {
        String s;
        s = HTMLString.link("/images/cow.gif","click for cow!", "/images/cow.gif");
        log.info(s);
        assertEquals("testLinkStringStringString", s, "<a href='/images/cow.gif'>click for cow!<img src='/images/cow.gif'></a>");
    }

    public void testBold() {

        String s;
        s = HTMLString.bold("hello");
        log.info(s);
        assertEquals("testBold", s, "<b>hello</b>");

    }

    public void testItalics() {
        String s;
        s = HTMLString.italics("hello");
        log.info(s);
        assertEquals("testItalics", s, "<i>hello</i>");
    }

    public void testBoolean() {
        String s = null;
        log.info( Boolean.parseBoolean(s) );
        assertFalse("null s/b false", Boolean.parseBoolean(s));

        s = "cow";
        log.info( Boolean.parseBoolean(s) );
        assertFalse("cow s/b false", Boolean.parseBoolean(s));

        s = "FALse";
        log.info( Boolean.parseBoolean(s) );
        assertFalse("FALse s/b false", Boolean.parseBoolean(s));

        s = "true";
        log.info( Boolean.parseBoolean(s) );
        assertTrue("true s/b true", Boolean.parseBoolean(s));

        s = "truE";
        log.info( Boolean.parseBoolean(s) );
        assertTrue("truE s/b true", Boolean.parseBoolean(s));

    }

}
