package net.sf.jolene.util;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import java.util.StringTokenizer;

/**
 * User: Dan
 * Date: Jul 13, 2008
 * Time: 5:09:22 PM
 */
public class Utils {

    public static String readFileAsString(String filePath) throws IOException {

        StringBuilder fileData = new StringBuilder(1024);
        BufferedReader reader = null;
        try {
            reader = new BufferedReader(new FileReader(filePath));
            char[] buf = new char[1024];
            int numRead = 0;
            while ((numRead = reader.read(buf)) != -1) {
                fileData.append(buf, 0, numRead);
            }
        } finally {
            if (reader != null) {
                reader.close();
            }
        }
        return fileData.toString();
    }


    public static Date getDateFromYYYYMMDDString(String dateString) {
        if (dateString == null) {
            return null;
        }
        StringTokenizer st = new StringTokenizer(dateString, "-/\\. ");
        int year = Integer.parseInt(st.nextToken(), 10);
        int month = Integer.parseInt(st.nextToken(), 10) - 1;
        int day = Integer.parseInt(st.nextToken(), 10);
        Calendar cal = Calendar.getInstance();
        cal.clear();
        cal.set(year, month, day);
        return cal.getTime();
    }

}
